// Scanlines
// Jorge Fuente-Alba
// PS 2.0
// darkens horizontal lines

//#PARAM float tot 60 : Total : Total of shown scanlines.
//#PARAM percent sw 0.2 : Width : Width of each darkened scanline.
//#PARAM percent intensity 0.1 : Intensity : Intensity of the effect.
//#PARAM percent offset 0 : Offset : Offset of the effect.
float tot;
float sw;
float intensity;
float offset;

// Foreground texture
texture ForegroundTexture;

// Background texture
texture BackgroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float4 color = tex2D( foreground, Tex.xy );
    float darken = 2*abs((((Tex.y*tot)+offset) %1)-0.5);
    darken = clamp(darken-sw+0.5,0,1);
    darken = 1-((1-darken)*(intensity));
    color.rgb *= float3( darken , darken , darken);

    return color;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();    
    }
}
